#include <stdio.h>
#include <string.h>
#include <inttypes.h>
#include <time.h>
#include <math.h>
#define MAX_KAPACITA 20000

int pocet_predmetu, kapacita_batohu, ceny[64], vahy[64], stavu;
typedef	struct { unsigned cena; uint64_t stav; } tab_t;

tab_t *dynamic(void)
{
	static tab_t tabulka[MAX_KAPACITA+1]; int i, j; 
	memset(tabulka, 0, sizeof(tab_t)*(kapacita_batohu+1));
	for( i = 0; i < pocet_predmetu; i++)
		for( j = kapacita_batohu; j >= vahy[i]; j--, stavu++)
			if( tabulka[j].cena < tabulka[ j - vahy[i] ].cena + ceny[i] ){
				tabulka[j].stav = tabulka[ j - vahy[i] ].stav | 1 << i;  
				tabulka[j].cena = tabulka[ j - vahy[i] ].cena + ceny[i];
			}
	return tabulka + kapacita_batohu;
}

int main(int argc, char *argv[])
{
	int i, zadani; tab_t *reseni; int polestavu[100], zadanich = 0, sum;
	while( scanf("%d%d%d", &zadani, &pocet_predmetu, &kapacita_batohu) == 3 ){
		for(i = 0; i < pocet_predmetu; i++)
			scanf("%d%d", vahy + i, ceny + i);
		stavu = 0; reseni = dynamic();
		polestavu[ zadanich++ ] = stavu;
	}
	for( sum = 0, i = 0; i < zadanich; i++ ) sum += polestavu[i];
	float EX = (float)sum/zadanich, DX = 0;
	for( i = 0; i < zadanich; i++ ) DX += (polestavu[i]-EX)*(polestavu[i]-EX)/zadanich;
	float DXa = 0, DXb = 0; int DXac = 0, DXbc = 0;
	for( i = 0; i < zadanich; i++ ) 
		if( polestavu[i] < EX ) DXa += (polestavu[i]-EX)*(polestavu[i]-EX), DXac++;
		else DXb += (polestavu[i]-EX)*(polestavu[i]-EX), DXbc++;

	printf("%f %f %f %f\n", EX, sqrtf(DX), EX-sqrtf(DXa/DXac), EX+sqrtf(DXb/DXbc));
	return 0;
}
