#include <stdio.h>
#include <inttypes.h>
#include <time.h>
#include <math.h>

int pocet_predmetu, kapacita_batohu, zadani, ceny[64], vahy[64], sumcen[64];
int max_cena; uint64_t nejlepsi_stav; int stavu;

struct predmet {int cena; int vaha; int poradi;} predmety[64], nej_predmet;

static int rad(const void *p1, const void *p2)
{
	struct predmet *b = (struct predmet*)p1, *a = (struct predmet*)p2;
	return b->cena - a->cena;
}

void r2(int vaha, int cena, int zanoreni, uint64_t stav){
	stavu++;
	if( zanoreni < pocet_predmetu ){
		if( cena + sumcen[zanoreni] < max_cena ) return;
		r2(vaha, cena, zanoreni + 1, stav);
		vaha += predmety[zanoreni].vaha;
		if( vaha <= kapacita_batohu ){
			cena += predmety[zanoreni].cena; stav |= (1 << predmety[zanoreni].poradi);
			r2(vaha, cena, zanoreni + 1, stav);
			if( cena > max_cena ){ max_cena = cena;	nejlepsi_stav = stav; }
		}
	} else {
		vaha += predmety[zanoreni].vaha;
		if( vaha <= kapacita_batohu ){
			cena += predmety[zanoreni].cena;
			if( cena > max_cena ){ max_cena = cena;	nejlepsi_stav = stav | (1<< predmety[zanoreni].poradi); }
		}
	}
}

int main(int argc, char *argv[])
{
	int i, zadanich = 0, polestavu[100], sum;
	while( scanf("%d%d%d", &zadani, &pocet_predmetu, &kapacita_batohu) == 3 ){
		for(i = 0; i < pocet_predmetu; i++)
			scanf("%d%d", &predmety[i].vaha, &predmety[i].cena), predmety[i].poradi = i;
		for(sumcen[pocet_predmetu - 1] = predmety[pocet_predmetu - 1].cena, i = pocet_predmetu - 2; i >= 0; i--)
			sumcen[i] = predmety[i].cena + sumcen[i+1]; 
		qsort( predmety, pocet_predmetu, sizeof(struct predmet), rad);
		max_cena = 0; nejlepsi_stav = 0; pocet_predmetu--; stavu = 0;
		r2(0, 0, 0, 0);
		polestavu[ zadanich++ ] = stavu;
	}
	for( sum = 0, i = 0; i < zadanich; i++ ) sum += polestavu[i];
	float EX = (float)sum/zadanich, DX = 0;
	for( i = 0; i < zadanich; i++ ) DX += (polestavu[i]-EX)*(polestavu[i]-EX)/zadanich;
	float DXa = 0, DXb = 0; int DXac = 0, DXbc = 0;
	for( i = 0; i < zadanich; i++ ) 
		if( polestavu[i] < EX ) DXa += (polestavu[i]-EX)*(polestavu[i]-EX), DXac++;
		else DXb += (polestavu[i]-EX)*(polestavu[i]-EX), DXbc++;

	printf("%f %f %f %f\n", EX, sqrtf(DX), EX-sqrtf(DXa/DXac), EX+sqrtf(DXb/DXbc));
	return 0;
}
