#include <stdio.h>
#include <string.h>
#include <inttypes.h>
#include <time.h>
#define MAX_KAPACITA 20000

int pocet_predmetu, kapacita_batohu, ceny[64], vahy[64];
typedef	struct { unsigned cena; uint64_t stav; } tab_t;

tab_t *dynamic(void)
{
	static tab_t tabulka[MAX_KAPACITA+1]; int i, j; 
	memset(tabulka, 0, sizeof(tab_t)*(kapacita_batohu+1));
	for( i = 0; i < pocet_predmetu; i++)
		for( j = kapacita_batohu; j >= vahy[i]; j--)
			if( tabulka[j].cena < tabulka[ j - vahy[i] ].cena + ceny[i] ){
				tabulka[j].stav = tabulka[ j - vahy[i] ].stav | 1 << i;  
				tabulka[j].cena = tabulka[ j - vahy[i] ].cena + ceny[i];
			}
	return tabulka + kapacita_batohu;
}

int main(int argc, char *argv[])
{
	int i, zadani; tab_t *reseni;
	while( scanf("%d%d%d", &zadani, &pocet_predmetu, &kapacita_batohu) == 3 ){
		for(i = 0; i < pocet_predmetu; i++)
			scanf("%d%d", vahy + i, ceny + i);
		reseni = dynamic();
		printf("%d %d %d ", zadani, pocet_predmetu, reseni->cena);
		for(i = 0; i < pocet_predmetu; i++)
			printf(" %d", reseni->stav & (1 << i) ? 1 : 0);
		printf("\n");
	}
	return 0;
}
